大家好,又见面了,我是你们的朋友全栈君。如果您正在找激活码,请点击查看最新教程,关注关注公众号 “全栈程序员社区” 获取激活教程,可能之前旧版本教程已经失效.最新Idea2022.1教程亲测有效,一键激活。
Jetbrains全系列IDE使用 1年只要46元 售后保障 童叟无欺
Pascal’s Travels
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 5328 | Accepted: 2396 |
Description
An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from the upper left corner to the lower right corner of the board. The integer in any one square dictates how large a step away from that location must be. If the step size would advance travel off the game board, then a step in that particular direction is forbidden. All steps must be either to the right or toward the bottom. Note that a 0 is a dead end which prevents any further progress.
Consider the 4 x 4 board shown in Figure 1, where the solid circle identifies the start position and the dashed circle identifies the target. Figure 2 shows the three paths from the start to the target, with the irrelevant numbers in each removed.
Figure 1 | Figure 2 |
Input
The input contains data for one to thirty boards, followed by a final line containing only the integer -1. The data for a board starts with a line containing a single positive integer n, 4 <= n <= 34, which is the number of rows in this board. This is followed by n rows of data. Each row contains n single digits, 0-9, with no spaces between them.
Output
The output consists of one line for each board, containing a single integer, which is the number of paths from the upper left corner to the lower right corner. There will be fewer than 263 paths for any board.
Sample Input
4
2331
1213
1231
3110
4
3332
1213
1232
2120
5
11101
01111
11111
11101
11101
-1
Sample Output
3
0
7
Hint
Brute force methods examining every path will likely exceed the allotted time limit. 64-bit integer values are available as long values in Java or long long values using the contest’s C/C++ compilers.
Source
题目链接:http://poj.org/problem?id=2704 http://acm.hdu.edu.cn/showproblem.php?pid=1208
题目大意:从左上角开始到右下角,每次只能向右或者向下,并且只能走当前位置点数的步数,求从起点到终点有多少种走法
题目分析:简单的记忆化搜索,dp[i][j]记录点(i,j)到终点的方案数,终点处为0需特殊处理
#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
int const MAX = 40;
int mp[MAX][MAX], n;
long long dp[MAX][MAX];
char s[100];
int dx[2] = {0, 1};
int dy[2] = {1, 0};
long long DFS(int x, int y) {
if (dp[x][y] != -1) {
return dp[x][y];
}
if (x == n && y == n) {
return 1;
}
long long ans = 0;
for (int i = 0; i < 2; i++) {
int xx = x + dx[i] * mp[x][y];
int yy = y + dy[i] * mp[x][y];
if (xx > n || yy > n || (mp[xx][yy] == 0 && !(xx == n && yy == n))) {
continue;
}
ans += DFS(xx, yy);
}
return dp[x][y] = ans;
}
int main() {
while (scanf("%d", &n) != EOF && n != -1) {
memset(dp, -1, sizeof(dp));
for (int i = 1; i <= n; i++) {
scanf("%s", s + 1);
for (int j = 1; j <= n; j++) {
mp[i][j] = s[j] - '0';
}
}
cout << DFS(1, 1) << endl;
}
}
发布者:全栈程序员-用户IM,转载请注明出处:https://javaforall.cn/164449.html原文链接:https://javaforall.cn
【正版授权,激活自己账号】: Jetbrains全家桶Ide使用,1年售后保障,每天仅需1毛
【官方授权 正版激活】: 官方授权 正版激活 支持Jetbrains家族下所有IDE 使用个人JB账号...